from OCC.BRep import *
from OCC.BRepMesh import *
from OCC.BRepPrimAPI import *
from OCC.TopAbs import *
from OCC.TopExp import *
from OCC.TopLoc import *
from OCC.TopoDS import *
from OCC.BRepBuilderAPI import *

def nbTriangles(s):
    m = BRepMesh_IncrementalMesh(s,7e-3,True)
    m.Perform()
    l = TopLoc_Location()
    pt = BRep_Tool_Triangulation(s,l).GetObject()
    return pt.NbTriangles()

def meshTorus(radius):
    print "radius: %i"%radius
    maker = BRepPrimAPI_MakeTorus(radius,1.)
    ex = TopExp_Explorer(maker.Shape(), TopAbs_FACE)
    primTorus = TopoDS_face(ex.Current())
    print "\tPrim Torus:%i"%nbTriangles(primTorus)
    converter = BRepBuilderAPI_NurbsConvert()
    converter.Perform(primTorus)
    nurbsTorus = TopoDS_face(converter.ModifiedShape(primTorus))
    print "\tNurbs Torus:%i"%nbTriangles(nurbsTorus)

for i in range(1,20):
    meshTorus(i)
